--- u-boot-2011.06_original/common/cmd_gpt.c	1970-01-01 08:00:00.000000000 +0800
+++ u-boot-2011.06/common/cmd_gpt.c	2014-07-29 17:28:38.819972000 +0800
@@ -0,0 +1,336 @@
+/*
+ * cmd_gpt.c -- GPT (GUID Partition Table) handling command
+ *
+ * Copyright (C) 2012 Samsung Electronics
+ * author: Lukasz Majewski <l.majewski@samsung.com>
+ * author: Piotr Wilczek <p.wilczek@samsung.com>
+ *
+ * SPDX-License-Identifier:	GPL-2.0+
+ */
+
+#include <common.h>
+#include <malloc.h>
+#include <command.h>
+#include <mmc.h>
+#include <part_efi.h>
+#include <exports.h>
+#include <linux/ctype.h>
+#include <div64.h>
+
+#ifndef CONFIG_PARTITION_UUIDS
+#error CONFIG_PARTITION_UUIDS must be enabled for CONFIG_CMD_GPT to be enabled
+#endif
+
+/**
+ * extract_env(): Expand env name from string format '&{env_name}'
+ *                and return pointer to the env (if the env is set)
+ *
+ * @param str - pointer to string
+ * @param env - pointer to pointer to extracted env
+ *
+ * @return - zero on successful expand and env is set
+ */
+static char extract_env(const char *str, char **env)
+{
+	char *e, *s;
+
+	if (!str || strlen(str) < 4)
+		return -1;
+
+	if ((strncmp(str, "${", 2) == 0) && (str[strlen(str) - 1] == '}')) {
+		s = strdup(str);
+		if (s == NULL)
+			return -1;
+		memset(s + strlen(s) - 1, '\0', 1);
+		memmove(s, s + 2, strlen(s) - 1);
+		e = getenv(s);
+		free(s);
+		if (e == NULL) {
+			printf("Environmental '%s' not set\n", str);
+			return -1; /* env not set */
+		}
+		*env = e;
+		return 0;
+	}
+
+	return -1;
+}
+
+/**
+ * extract_val(): Extract value from a key=value pair list (comma separated).
+ *                Only value for the given key is returend.
+ *                Function allocates memory for the value, remember to free!
+ *
+ * @param str - pointer to string with key=values pairs
+ * @param key - pointer to the key to search for
+ *
+ * @return - pointer to allocated string with the value
+ */
+static char *extract_val(const char *str, const char *key)
+{
+	char *v, *k;
+	char *s, *strcopy;
+	char *new = NULL;
+
+	strcopy = strdup(str);
+	if (strcopy == NULL)
+		return NULL;
+
+	s = strcopy;
+	while (s) {
+		v = strsep(&s, ",");
+		if (!v)
+			break;
+		k = strsep(&v, "=");
+		if (!k)
+			break;
+		if  (strcmp(k, key) == 0) {
+			new = strdup(v);
+			break;
+		}
+	}
+
+	free(strcopy);
+
+	return new;
+}
+
+/**
+ * set_gpt_info(): Fill partition information from string
+ *		function allocates memory, remember to free!
+ *
+ * @param dev_desc - pointer block device descriptor
+ * @param str_part - pointer to string with partition information
+ * @param str_disk_guid - pointer to pointer to allocated string with disk guid
+ * @param partitions - pointer to pointer to allocated partitions array
+ * @param parts_count - number of partitions
+ *
+ * @return - zero on success, otherwise error
+ *
+ */
+static int set_gpt_info(block_dev_desc_t *dev_desc,
+			const char *str_part,
+			char **str_disk_guid,
+			disk_partition_t **partitions,
+			u8 *parts_count)
+{
+	char *tok, *str, *s;
+	int i;
+	char *val, *p;
+	int p_count;
+	disk_partition_t *parts;
+	int errno = 0;
+	uint64_t size_ll, start_ll;
+
+	debug("%s: MMC lba num: 0x%x %d\n", __func__,
+	      (unsigned int)dev_desc->lba, (unsigned int)dev_desc->lba);
+
+	if (str_part == NULL)
+		return -1;
+
+	str = strdup(str_part);
+
+	/* extract disk guid */
+	s = str;
+	tok = strsep(&s, ";");
+	val = extract_val(tok, "uuid_disk");
+	debug("val = %s\n",val);
+	if (!val) {
+		free(str);
+		return -2;
+	}
+	if (extract_env(val, &p)){
+		p = val;
+	}
+	*str_disk_guid = strdup(p);
+	free(val);
+
+	if (strlen(s) == 0)
+		return -3;
+
+	i = strlen(s) - 1;
+	if (s[i] == ';')
+		s[i] = '\0';
+
+	/* calculate expected number of partitions */
+	p_count = 1;
+	p = s;
+	while (*p) {
+		if (*p++ == ';')
+			p_count++;
+	}
+	debug("p_count = %d\n", p_count);
+	/* allocate memory for partitions */
+	parts = calloc(sizeof(disk_partition_t), p_count);
+
+	/* retrieve partitions data from string */
+	for (i = 0; i < p_count; i++) {
+		tok = strsep(&s, ";");
+		debug("tok = %s\n", tok);
+		if (tok == NULL)
+			break;
+
+		/* uuid */
+		val = extract_val(tok, "uuid");
+		debug("uid = %s\n", val);
+		if (!val) { /* 'uuid' is mandatory */
+			errno = -4;
+			goto err;
+		}
+		if (extract_env(val, &p)){
+			p = val;
+		}
+		if (strlen(p) >= sizeof(parts[i].uuid)) {
+			debug("Wrong uuid format for partition %d\n", i);
+			errno = -4;
+			goto err;
+		}
+		strcpy((char *)parts[i].uuid, p);
+		free(val);
+
+		/* name */
+		val = extract_val(tok, "name");
+		debug("name = %s\n",val);
+		if (!val) { /* name is mandatory */
+			errno = -4;
+			goto err;
+		}
+		if (extract_env(val, &p)){
+			p = val;
+		}
+		if (strlen(p) >= sizeof(parts[i].name)) {
+			errno = -4;
+			goto err;
+		}
+		strcpy((char *)parts[i].name, p);
+		free(val);
+
+		/* size */
+		val = extract_val(tok, "size");
+		debug("size = %s\n", val);
+		if (!val) { /* 'size' is mandatory */
+			errno = -4;
+			goto err;
+		}
+		if (extract_env(val, &p)){
+			p = val;
+		}
+		size_ll = ustrtoull(p, &p, 0);
+		debug("size_ll = 0x%llx, dev_desc->blksz = 0x%lx\n",size_ll, dev_desc->blksz);
+		parts[i].size = lldiv(size_ll, dev_desc->blksz);
+		debug("parts[%d].size = 0x%lx\n",i,parts[i].size);
+		free(val);
+
+		/* start address */
+		val = extract_val(tok, "start");
+		debug("val = %s\n",val);
+		if (val) { /* start address is optional */
+			if (extract_env(val, &p))
+				p = val;
+			start_ll = ustrtoull(p, &p, 0);
+			debug("wwwsize_ll = 0x%llx, dev_desc->blksz = 0x%lx\n",size_ll, dev_desc->blksz);
+			parts[i].start = lldiv(start_ll, dev_desc->blksz);
+			debug("wwwparts[%d].size = 0x%lx\n",i,parts[i].size);
+			free(val);
+		}
+	}
+
+	*parts_count = p_count;
+	*partitions = parts;
+	free(str);
+
+	return 0;
+err:
+	free(str);
+	free(*str_disk_guid);
+	free(parts);
+
+	return errno;
+}
+
+static int gpt_mmc_default(int dev, const char *str_part)
+{
+	int ret;
+	char *str_disk_guid;
+	u8 part_count = 0;
+	disk_partition_t *partitions = NULL;
+
+	struct mmc *mmc = find_mmc_device(dev);
+
+	if (mmc == NULL) {
+		printf("%s: mmc dev %d NOT available\n", __func__, dev);
+		return CMD_RET_FAILURE;
+	}
+
+	if (!str_part)
+		return -1;
+
+	/* fill partitions */
+	ret = set_gpt_info(&mmc->block_dev, str_part,
+			&str_disk_guid, &partitions, &part_count);
+	if (ret) {
+		if (ret == -1)
+			printf("No partition list provided\n");
+		if (ret == -2)
+			printf("Missing disk guid\n");
+		if ((ret == -3) || (ret == -4))
+			printf("Partition list incomplete\n");
+		return -1;
+	}
+
+	/* save partitions layout to disk */
+	gpt_restore(&mmc->block_dev, str_disk_guid, partitions, part_count);
+	free(str_disk_guid);
+	free(partitions);
+
+	return 0;
+}
+
+/**
+ * do_gpt(): Perform GPT operations
+ *
+ * @param cmdtp - command name
+ * @param flag
+ * @param argc
+ * @param argv
+ *
+ * @return zero on success; otherwise error
+ */
+int do_gpt(cmd_tbl_t *cmdtp, int flag, int argc, char * const argv[])
+{
+	int ret = CMD_RET_SUCCESS;
+	int dev = 0;
+	char *pstr;
+
+	if (argc < 5)
+		return CMD_RET_USAGE;
+
+	/* command: 'write' */
+	if ((strcmp(argv[1], "write") == 0) && (argc == 5)) {
+		/* device: 'mmc' */
+		if (strcmp(argv[2], "mmc") == 0) {
+			/* check if 'dev' is a number */
+			for (pstr = argv[3]; *pstr != '\0'; pstr++)
+				if (!isdigit(*pstr)) {
+					printf("'%s' is not a number\n",
+						argv[3]);
+					return CMD_RET_USAGE;
+				}
+			dev = (int)simple_strtoul(argv[3], NULL, 10);
+			/* write to mmc */
+			if (gpt_mmc_default(dev, argv[4]))
+				return CMD_RET_FAILURE;
+		}
+	} else {
+		return CMD_RET_USAGE;
+	}
+	return ret;
+}
+
+U_BOOT_CMD(gpt, CONFIG_SYS_MAXARGS, 1, do_gpt,
+	"GUID Partition Table",
+	"<command> <interface> <dev> <partitions_list>\n"
+	" - GUID partition table restoration\n"
+	" Restore GPT information on a device connected\n"
+	" to interface\n"
+);
diff '--exclude=.svn' -Naur u-boot-2011.06_original/common/cmd_mem.c u-boot-2011.06/common/cmd_mem.c
--- u-boot-2011.06_original/common/cmd_mem.c	2011-06-28 04:22:42.000000000 +0800
+++ u-boot-2011.06/common/cmd_mem.c	2014-07-29 17:28:38.819972000 +0800
@@ -42,6 +42,11 @@
 
 static int mod_mem(cmd_tbl_t *, int, int, int, char * const []);
 
+#ifdef CONFIG_CMD_SEC1900_MEM_PROTECT
+extern int check_write_to_code_area (unsigned long addr, unsigned long size);
+#endif
+
+
 /* Display values from last command.
  * Memory modify remembered values are different from display memory.
  */
@@ -180,6 +185,10 @@
 	addr = simple_strtoul(argv[1], NULL, 16);
 	addr += base_address;
 
+#ifdef CONFIG_CMD_SEC1900_MEM_PROTECT
+	if (check_write_to_code_area (addr, size))
+		return -1;
+#endif
 	/* Get the value to write.
 	*/
 	writeval = simple_strtoul(argv[2], NULL, 16);
@@ -410,6 +419,11 @@
 		return 0;
 	}
 
+#ifdef CONFIG_CMD_SEC1900_MEM_PROTECT
+	if (check_write_to_code_area (dest, count*size))
+		return -1;
+#endif
+
 	/* Check if we are copying from DataFlash to RAM */
 	if (addr_dataflash(addr) && !addr_dataflash(dest)
 #ifndef CONFIG_SYS_NO_FLASH
@@ -471,12 +485,12 @@
 
 int do_mem_loop (cmd_tbl_t *cmdtp, int flag, int argc, char * const argv[])
 {
-	ulong	addr, length, i, junk;
+	ulong	addr, length, i, junk=0;
 	int	size;
 	volatile uint	*longp;
 	volatile ushort *shortp;
 	volatile u_char	*cp;
-
+	junk=junk;
 	if (argc < 3)
 		return cmd_usage(cmdtp);
 
@@ -535,11 +549,18 @@
 		while (i-- > 0)
 			junk = *cp++;
 	}
+	return 0;
 }
-
+#undef CONFIG_LOOPW
 #ifdef CONFIG_LOOPW
 int do_mem_loopw (cmd_tbl_t *cmdtp, int flag, int argc, char * const argv[])
 {
+	struct pattern{
+		unsigned int burst[4];
+	};
+	const struct pattern pp = {
+		{0x0000ffff, 0x0000ffff, 0x0000ffff, 0x0000ffff}
+	};
 	ulong	addr, length, i, data;
 	int	size;
 	volatile uint	*longp;
@@ -562,7 +583,7 @@
 	/* Length is the number of objects, not number of bytes.
 	*/
 	length = simple_strtoul(argv[2], NULL, 16);
-
+#if 0
 	/* data to write */
 	data = simple_strtoul(argv[3], NULL, 16);
 
@@ -607,6 +628,14 @@
 		while (i-- > 0)
 			*cp++ = data;
 	}
+#endif
+	for(;;){
+		*(struct pattern *)(addr+0x0000000) = pp;
+		*(struct pattern *)(addr+0x0000010) = pp;
+		*(struct pattern *)(addr+0x0000020) = pp;
+		*(struct pattern *)(addr+0x0000030) = pp;
+	}
+
 }
 #endif /* CONFIG_LOOPW */
 
@@ -619,7 +648,7 @@
 {
 	vu_long	*addr, *start, *end;
 	ulong	val;
-	ulong	readback;
+//	ulong	readback;
 	ulong	errs = 0;
 	int iterations = 1;
 	int iteration_limit;
@@ -650,8 +679,9 @@
 		0xaaaaaaaa,	/* alternating 1/0 */
 	};
 #else
-	ulong	incr;
+	ulong	incr=0;
 	ulong	pattern;
+	incr=incr;
 #endif
 
 	if (argc > 1)
@@ -926,9 +956,9 @@
 		for (addr=start,val=pattern; addr<end; addr++) {
 			WATCHDOG_RESET();
 			*addr = val;
-			val  += incr;
+//			val  += incr;
 		}
-
+#if 0
 		puts ("Reading...");
 
 		for (addr=start,val=pattern; addr<end; addr++) {
@@ -944,22 +974,23 @@
 					return 1;
 				}
 			}
-			val += incr;
+		//	val += incr;
 		}
-
+#endif
 		/*
 		 * Flip the pattern each time to make lots of zeros and
 		 * then, the next time, lots of ones.  We decrement
 		 * the "negative" patterns and increment the "positive"
 		 * patterns to preserve this feature.
 		 */
-		if(pattern & 0x80000000) {
-			pattern = -pattern;	/* complement & increment */
-		}
-		else {
+//		if(pattern & 0x80000000) {
+//			pattern = -pattern;	/* complement & increment */
+//		}
+
+//		else{
 			pattern = ~pattern;
-		}
-		incr = -incr;
+//		}
+		//incr = -incr;
 	}
 #endif
 	return 0;	/* not reached */
@@ -1022,6 +1053,10 @@
 	 * the next value.  A non-converted value exits.
 	 */
 	do {
+#ifdef CONFIG_CMD_SEC1900_MEM_PROTECT
+	        if (check_write_to_code_area (addr, size))
+	        	return -1;
+#endif
 		printf("%08lx:", addr);
 		if (size == 4)
 			printf(" %08x", *((uint   *)addr));
diff '--exclude=.svn' -Naur u-boot-2011.06_original/common/cmd_mmc.c u-boot-2011.06/common/cmd_mmc.c
--- u-boot-2011.06_original/common/cmd_mmc.c	2011-06-28 04:22:42.000000000 +0800
+++ u-boot-2011.06/common/cmd_mmc.c	2014-07-29 17:28:38.819972000 +0800
@@ -53,7 +53,8 @@
 
 		curr_device = dev;
 		printf("mmc%d is available\n", curr_device);
-	} else if (strcmp(argv[1], "device") == 0) {
+	} 
+	else if (strcmp(argv[1], "device") == 0) {
 		if (argc == 2) {
 			if (curr_device < 0) {
 				puts("No MMC device available\n");
@@ -87,6 +88,12 @@
 );
 #else /* !CONFIG_GENERIC_MMC */
 
+enum mmc_state {
+	MMC_INVALID,
+	MMC_READ,
+	MMC_WRITE,
+	MMC_ERASE,
+};
 static void print_mmcinfo(struct mmc *mmc)
 {
 	printf("Device: %s\n", mmc->name);
@@ -100,7 +107,7 @@
 	printf("Rd Block Len: %d\n", mmc->read_bl_len);
 
 	printf("%s version %d.%d\n", IS_SD(mmc) ? "SD" : "MMC",
-			(mmc->version >> 4) & 0xf, mmc->version & 0xf);
+			(mmc->version >> 8) & 0xf, mmc->version & 0xff);
 
 	printf("High Capacity: %s\n", mmc->high_capacity ? "Yes" : "No");
 	puts("Capacity: ");
@@ -138,12 +145,14 @@
 U_BOOT_CMD(
 	mmcinfo, 1, 0, do_mmcinfo,
 	"display MMC info",
-	"    - device number of the device to dislay info of\n"
+	"    - device number of the device to display info of\n"
 	""
 );
 
 int do_mmcops(cmd_tbl_t *cmdtp, int flag, int argc, char * const argv[])
 {
+	enum mmc_state state;
+
 	if (argc < 2)
 		return cmd_usage(cmdtp);
 
@@ -165,9 +174,11 @@
 		}
 
 		mmc->has_init = 0;
-		mmc_init(mmc);
 
-		return 0;
+		if (mmc_init(mmc))
+			return 1;
+		else
+			return 0;
 	} else if (strncmp(argv[1], "part", 4) == 0) {
 		block_dev_desc_t *mmc_dev;
 		struct mmc *mmc = find_mmc_device(curr_device);
@@ -227,7 +238,7 @@
 				if (!ret)
 					mmc->part_num = part;
 
-				printf("switch to partions #%d, %s\n",
+				printf("switch to partitions #%d, %s\n",
 						part, (!ret) ? "OK" : "ERROR");
 			}
 		}
@@ -239,53 +250,61 @@
 				curr_device, mmc->part_num);
 
 		return 0;
-	} else if (strcmp(argv[1], "read") == 0) {
-		void *addr = (void *)simple_strtoul(argv[2], NULL, 16);
-		u32 cnt = simple_strtoul(argv[4], NULL, 16);
-		u32 n;
-		u32 blk = simple_strtoul(argv[3], NULL, 16);
-		struct mmc *mmc = find_mmc_device(curr_device);
-
-		if (!mmc) {
-			printf("no mmc device at slot %x\n", curr_device);
-			return 1;
-		}
-
-		printf("\nMMC read: dev # %d, block # %d, count %d ... ",
-				curr_device, blk, cnt);
-
-		mmc_init(mmc);
-
-		n = mmc->block_dev.block_read(curr_device, blk, cnt, addr);
+	}
 
-		/* flush cache after read */
-		flush_cache((ulong)addr, cnt * 512); /* FIXME */
+	if (strcmp(argv[1], "read") == 0)
+		state = MMC_READ;
+	else if (strcmp(argv[1], "write") == 0)
+		state = MMC_WRITE;
+	else if (strcmp(argv[1], "erase") == 0)
+		state = MMC_ERASE;
+	else
+		state = MMC_INVALID;
 
-		printf("%d blocks read: %s\n",
-				n, (n==cnt) ? "OK" : "ERROR");
-		return (n == cnt) ? 0 : 1;
-	} else if (strcmp(argv[1], "write") == 0) {
-		void *addr = (void *)simple_strtoul(argv[2], NULL, 16);
-		u32 cnt = simple_strtoul(argv[4], NULL, 16);
-		u32 n;
+	if (state != MMC_INVALID) {
 		struct mmc *mmc = find_mmc_device(curr_device);
-
-		int blk = simple_strtoul(argv[3], NULL, 16);
+		int idx = 2;
+		u32 blk, cnt, n;
+		void *addr;
+
+		if (state != MMC_ERASE) {
+			addr = (void *)simple_strtoul(argv[idx], NULL, 16);
+			++idx;
+		} else
+			addr = 0;
+		blk = simple_strtoul(argv[idx], NULL, 16);
+		cnt = simple_strtoul(argv[idx + 1], NULL, 16);
 
 		if (!mmc) {
 			printf("no mmc device at slot %x\n", curr_device);
 			return 1;
 		}
 
-		printf("\nMMC write: dev # %d, block # %d, count %d ... ",
-				curr_device, blk, cnt);
+		printf("\nMMC %s: dev # %d, block # %d, count %d ... ",
+				argv[1], curr_device, blk, cnt);
 
 		mmc_init(mmc);
 
-		n = mmc->block_dev.block_write(curr_device, blk, cnt, addr);
+		switch (state) {
+		case MMC_READ:
+			n = mmc->block_dev.block_read(curr_device, blk,
+						      cnt, addr);
+			/* flush cache after read */
+			flush_cache((ulong)addr, cnt * 512); /* FIXME */
+			break;
+		case MMC_WRITE:
+			n = mmc->block_dev.block_write(curr_device, blk,
+						      cnt, addr);
+			break;
+		case MMC_ERASE:
+			n = mmc->block_dev.block_erase(curr_device, blk, cnt);
+			break;
+		default:
+			BUG();
+		}
 
-		printf("%d blocks written: %s\n",
-				n, (n == cnt) ? "OK" : "ERROR");
+		printf("%d blocks %s: %s\n",
+				n, argv[1], (n == cnt) ? "OK" : "ERROR");
 		return (n == cnt) ? 0 : 1;
 	}
 
@@ -297,6 +316,7 @@
 	"MMC sub system",
 	"read addr blk# cnt\n"
 	"mmc write addr blk# cnt\n"
+	"mmc erase blk# cnt\n"
 	"mmc rescan\n"
 	"mmc part - lists available partition on current mmc device\n"
 	"mmc dev [dev] [part] - show or set current mmc device [partition]\n"
diff '--exclude=.svn' -Naur u-boot-2011.06_original/common/cmd_nand.c u-boot-2011.06/common/cmd_nand.c
--- u-boot-2011.06_original/common/cmd_nand.c	2011-06-28 04:22:42.000000000 +0800
+++ u-boot-2011.06/common/cmd_nand.c	2014-07-29 17:28:38.819972000 +0800
@@ -470,7 +470,8 @@
 		int chip = 0;
 		int spread = 0;
 		int args = 2;
-
+		chip=chip;
+		part=part;
 		if (cmd[5] != 0) {
 			if (!strcmp(&cmd[5], ".spread")) {
 				spread = 1;
diff '--exclude=.svn' -Naur u-boot-2011.06_original/common/cmd_nvedit.c u-boot-2011.06/common/cmd_nvedit.c
--- u-boot-2011.06_original/common/cmd_nvedit.c	2011-06-28 04:22:42.000000000 +0800
+++ u-boot-2011.06/common/cmd_nvedit.c	2014-07-29 17:28:38.819972000 +0800
@@ -459,8 +459,8 @@
 {
 	char buffer[CONFIG_SYS_CBSIZE];
 	char *init_val;
-	int len;
-
+	int len=0;
+	len=len;
 	if (argc < 2)
 		return cmd_usage(cmdtp);
 
diff '--exclude=.svn' -Naur u-boot-2011.06_original/common/cmd_sec_env.c u-boot-2011.06/common/cmd_sec_env.c
